diff --git a/configure.in b/configure.in
index d77b97c..04e1356 100644
--- a/configure.in
+++ b/configure.in
@@ -70,6 +70,18 @@ AC_CHECK_LIB([crypto], [EVP_DigestUpdate],
 AC_SUBST([CRYPTO_PACKAGE])
 AC_SUBST(CRYPTOLIB, -lcrypto)
 
+AM_CONDITIONAL(OS_WIN32, false)
+
+case ${host_os} in
+	*mingw32*)
+		AC_LIBTOOL_WIN32_DLL
+		AC_SUBST(EXTRATCSLIB, "-lws2_32 -ltbs")
+		AC_SUBST(EXTRATSPLIB, "-lws2_32 -luserenv -liconv")
+		AM_CONDITIONAL(OS_WIN32, true)
+		CFLAGS="$CFLAGS -D__USE_MINGW_ANSI_STDIO=1"
+		;;
+esac
+
 AC_ARG_ENABLE(gcov,
 		[AC_HELP_STRING([--enable-gcov], [turn on gcov code coverage flags [default=off]])],
 		[CFLAGS="$CFLAGS -ftest-coverage -fprofile-arcs"
@@ -385,6 +397,7 @@ AC_OUTPUT(dist/tcsd.conf \
 	  Makefile \
 	  src/Makefile \
 	  src/include/Makefile \
+	  src/win32/Makefile \
 	  src/tcs/Makefile \
 	  src/tddl/Makefile \
 	  src/tspi/Makefile \
diff --git a/src/Makefile.am b/src/Makefile.am
index 85dc2ea..529e00f 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -1 +1,7 @@
-SUBDIRS = trspi tddl tcs tspi tcsd include
+SUBDIRS =
+
+if OS_WIN32
+SUBDIRS += win32
+endif
+
+SUBDIRS += trspi tddl tcs tspi tcsd include
diff --git a/src/include/flock.h b/src/include/flock.h
new file mode 100644
index 0000000..f28a428
--- /dev/null
+++ b/src/include/flock.h
@@ -0,0 +1,21 @@
+#ifndef _FLOCK_H_
+#define _FLOCK_H_
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+/* Operations for the 'flock' call (same as Linux kernel constants).  */
+# define LOCK_SH 1       /* Shared lock.  */
+# define LOCK_EX 2       /* Exclusive lock.  */
+# define LOCK_UN 8       /* Unlock.  */
+
+/* Can be OR'd in to one of the above.  */
+# define LOCK_NB 4       /* Don't block when locking.  */
+
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* _FLOCK_H_ */
diff --git a/src/include/libc_interface.h b/src/include/libc_interface.h
new file mode 100644
index 0000000..ebba365
--- /dev/null
+++ b/src/include/libc_interface.h
@@ -0,0 +1,170 @@
+/*
+ * purple
+ *
+ * File: libc_interface.h
+ *
+ * Copyright (C) 2002-2003, Herman Bloggs <hermanator12002@yahoo.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111-1301  USA
+ *
+ */
+#ifndef _LIBC_INTERFACE_H_
+#define _LIBC_INTERFACE_H_
+#include "libc_internal.h"
+//#include <glib.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+#ifdef _MSC_VER
+#define S_IRUSR S_IREAD
+#define S_IWUSR S_IWRITE
+#define S_IXUSR S_IEXEC
+
+#define S_ISDIR(m)	 (((m)&S_IFDIR)==S_IFDIR)
+
+#define F_OK 0
+#endif
+
+#ifdef WIN32
+#define UINT16_MAX 0xffff
+#endif
+
+/* sys/socket.h */
+#define socket( domain, style, protocol ) \
+wpurple_socket( domain, style, protocol )
+
+#define connect( socket, addr, length ) \
+wpurple_connect( socket, addr, length )
+
+#define getsockopt( socket, level, optname, optval, optlenptr ) \
+wpurple_getsockopt( socket, level, optname, optval, optlenptr )
+
+#define setsockopt( socket, level, optname, optval, optlen ) \
+wpurple_setsockopt( socket, level, optname, optval, optlen )
+
+#define getsockname( socket, addr, lenptr ) \
+wpurple_getsockname( socket, addr, lenptr )
+
+#define bind( socket, addr, length ) \
+wpurple_bind( socket, addr, length )
+
+#define listen( socket, n ) \
+wpurple_listen( socket, n )
+
+#define sendto(socket, buf, len, flags, to, tolen) \
+wpurple_sendto(socket, buf, len, flags, to, tolen)
+
+#define recv(fd, buf, len, flags) \
+wpurple_recv(fd, buf, len, flags)
+
+#define send(socket, buf, buflen, flags) \
+wpurple_send(socket, buf, buflen, flags)
+
+/* sys/ioctl.h */
+#define ioctl( fd, command, val ) \
+wpurple_ioctl( fd, command, val )
+
+/* fcntl.h */
+#define fcntl( fd, command, ... ) \
+wpurple_fcntl( fd, command, ##__VA_ARGS__ )
+
+/* arpa/inet.h */
+#define inet_aton( name, addr ) \
+wpurple_inet_aton( name, addr )
+
+#define inet_ntop( af, src, dst, cnt ) \
+wpurple_inet_ntop( af, src, dst, cnt )
+
+/* netdb.h */
+#define gethostbyname( name ) \
+wpurple_gethostbyname( name )
+
+/* netinet/in.h */
+#define ntohl( netlong ) \
+(unsigned int)ntohl( netlong )
+
+/* string.h */
+#define hstrerror( herror ) \
+wpurple_strerror( errno )
+#define strerror( errornum ) \
+wpurple_strerror( errornum )
+#define g_strerror( errornum ) \
+wpurple_strerror( errornum )
+
+/* unistd.h */
+#define read( fd, buf, buflen ) \
+wpurple_read( fd, buf, buflen )
+
+#define write( socket, buf, buflen ) \
+wpurple_write( socket, buf, buflen )
+
+#define close( fd ) \
+wpurple_close( fd )
+
+#ifndef sleep
+#define sleep(x) Sleep((x)*1000)
+#endif
+
+#define gethostname( name, size ) \
+wpurple_gethostname( name, size )
+
+#define fsync(fd) _commit(fd)
+
+/* sys/time.h */
+#define gettimeofday( timeval, timezone ) \
+wpurple_gettimeofday( timeval, timezone )
+
+/* stdio.h */
+#undef snprintf
+#define snprintf _snprintf
+//#undef vsnprintf
+//#define vsnprintf _vsnprintf
+
+//#define rename( oldname, newname ) wpurple_rename( oldname, newname )
+
+/* sys/stat.h */
+#define fchmod(a,b)
+
+/* time.h */
+//#define localtime_r( time, resultp ) wpurple_localtime_r( time, resultp )
+
+#define flock( fd, operation ) \
+trousers_flock( fd, operation )
+
+#define strncasecmp( s1, s2, n ) \
+trousers_strncasecmp( s1, s2, n )
+
+#define strcasecmp( s1, s2 ) \
+trousers_strcasecmp( s1, s2 )
+
+#define ftruncate( fd, head_offset ) \
+_chsize( fd, head_offset )
+
+#define mlock( addr, len ) \
+trousers_mlock( addr, len)
+
+#define munlock( addr, len ) \
+trousers_munlock( addr, len)
+
+#define mkdir( path, mask ) \
+_mkdir( path )
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* _LIBC_INTERFACE_H_ */
diff --git a/src/include/libc_internal.h b/src/include/libc_internal.h
new file mode 100644
index 0000000..675445c
--- /dev/null
+++ b/src/include/libc_internal.h
@@ -0,0 +1,156 @@
+/*
+ * purple
+ *
+ * File: libc_internal.h
+ *
+ * Copyright (C) 2002-2003, Herman Bloggs <hermanator12002@yahoo.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111-1301  USA
+ *
+ */
+#ifndef _LIBC_INTERNAL_
+#define _LIBC_INTERNAL_
+//#include <glib.h>
+
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+/* helper for purple_utf8_strftime() by way of purple_internal_strftime() in src/util.c */
+//const char *wpurple_get_timezone_abbreviation(const struct tm *tm);
+
+/* sys/socket.h */
+int wpurple_socket(int domain, int style, int protocol);
+int wpurple_connect(int socket, struct sockaddr *addr, u_long length);
+int wpurple_getsockopt(int socket, int level, int optname, void *optval, socklen_t *optlenptr);
+int wpurple_setsockopt(int socket, int level, int optname, const void *optval, socklen_t optlen);
+int wpurple_getsockname (int socket, struct sockaddr *addr, socklen_t *lenptr);
+int wpurple_bind(int socket, struct sockaddr *addr, socklen_t length);
+int wpurple_listen(int socket, unsigned int n);
+int wpurple_sendto(int socket, const void *buf, size_t len, int flags, const struct sockaddr *to, socklen_t tolen);
+int wpurple_recv(int fd, void *buf, size_t len, int flags);
+int wpurple_send(int fd, const void *buf, unsigned int size, int flags);
+
+/* arpa/inet.h */
+int wpurple_inet_aton(const char *name, struct in_addr *addr);
+const char *
+wpurple_inet_ntop (int af, const void *src, char *dst, socklen_t cnt);
+
+/* netdb.h */
+struct hostent* wpurple_gethostbyname(const char *name);
+
+/* string.h */
+char* wpurple_strerror( int errornum );
+
+/* fcntl.h */
+int wpurple_fcntl(int socket, int command, ...);
+#define F_GETFL 3
+#define F_SETFL 4
+#define O_NONBLOCK 04000
+
+/* sys/ioctl.h */
+#define SIOCGIFCONF 0x8912 /* get iface list */
+int wpurple_ioctl(int fd, int command, void* opt);
+
+/* net/if.h */
+struct ifreq
+{
+	union
+	{
+		char ifrn_name[6];	/* Interface name, e.g. "en0".  */
+	} ifr_ifrn;
+
+	union
+	{
+		struct sockaddr ifru_addr;
+#if 0
+		struct sockaddr ifru_dstaddr;
+		struct sockaddr ifru_broadaddr;
+		struct sockaddr ifru_netmask;
+		struct sockaddr ifru_hwaddr;
+		short int ifru_flags;
+		int ifru_ivalue;
+		int ifru_mtu;
+#endif
+		char *ifru_data;
+	} ifr_ifru;
+};
+# define ifr_name	ifr_ifrn.ifrn_name	/* interface name       */
+# define ifr_addr	ifr_ifru.ifru_addr      /* address              */
+#if 0
+# define ifr_hwaddr	ifr_ifru.ifru_hwaddr	/* MAC address          */
+# define ifr_dstaddr	ifr_ifru.ifru_dstaddr	/* other end of p-p lnk */
+# define ifr_broadaddr	ifr_ifru.ifru_broadaddr	/* broadcast address    */
+# define ifr_netmask	ifr_ifru.ifru_netmask	/* interface net mask   */
+# define ifr_flags	ifr_ifru.ifru_flags	/* flags                */
+# define ifr_metric	ifr_ifru.ifru_ivalue	/* metric               */
+# define ifr_mtu	ifr_ifru.ifru_mtu	/* mtu                  */
+#endif
+# define ifr_data	ifr_ifru.ifru_data	/* for use by interface */
+#if 0
+# define ifr_ifindex	ifr_ifru.ifru_ivalue	/* interface index      */
+# define ifr_bandwidth	ifr_ifru.ifru_ivalue	/* link bandwidth       */
+# define ifr_qlen	ifr_ifru.ifru_ivalue	/* queue length         */
+#endif
+
+
+struct ifconf
+{
+	int ifc_len;			/* Size of buffer.  */
+	union
+	{
+		char *ifcu_buf;
+		struct ifreq *ifcu_req;
+	} ifc_ifcu;
+};
+# define ifc_buf ifc_ifcu.ifcu_buf /* Buffer address.  */
+# define ifc_req ifc_ifcu.ifcu_req /* Array of structures.  */
+
+/* sys/time.h */
+#if __MINGW32_MAJOR_VERSION < 3 || (__MINGW32_MAJOR_VERSION == 3 && __MINGW32_MINOR_VERSION < 10)
+struct timezone {
+	int tz_minuteswest;
+	int tz_dsttime;
+};
+#else
+#    include <sys/time.h>
+#endif
+int wpurple_gettimeofday(struct timeval *p, struct timezone *z);
+
+/* time.h */
+struct tm *wpurple_localtime_r(const time_t *time, struct tm *resultp);
+
+
+/* unistd.h */
+int wpurple_read(int fd, void *buf, unsigned int size);
+int wpurple_write(int fd, const void *buf, unsigned int size);
+int wpurple_close(int fd);
+int wpurple_gethostname(char *name, size_t size);
+
+
+/* stdio.h */
+//int wpurple_rename(const char *oldname, const char *newname);
+int trousers_flock(int fd, int operation);
+int trousers_strncasecmp(char *s1, char *s2, size_t n);
+int trousers_strcasecmp(char *s1, char *s2);
+int trousers_mlock(const void *addr, size_t len);
+int trousers_munlock(const void *addr, size_t len);
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* _LIBC_INTERNAL_ */
diff --git a/src/include/obj_policy.h b/src/include/obj_policy.h
index 90cd7ec..9686275 100644
--- a/src/include/obj_policy.h
+++ b/src/include/obj_policy.h
@@ -152,6 +152,7 @@ TSS_RESULT obj_policy_set_hash_mode(TSS_HPOLICY, UINT32);
 TSS_RESULT obj_policy_get_xsap_params(TSS_HPOLICY, TPM_COMMAND_CODE, TPM_ENTITY_TYPE *, UINT32 *,
 				      BYTE **, BYTE *, TSS_CALLBACK *, TSS_CALLBACK *,
 				      TSS_CALLBACK *, UINT32 *, TSS_BOOL);
+TSS_RESULT obj_policy_is_secret_set(TSS_HPOLICY, TSS_BOOL *);
 #ifdef TSS_BUILD_DELEGATION
 TSS_RESULT obj_policy_set_delegation_type(TSS_HPOLICY, UINT32);
 TSS_RESULT obj_policy_get_delegation_type(TSS_HPOLICY, UINT32 *);
diff --git a/src/include/spi_utils.h b/src/include/spi_utils.h
index f93e877..52d5fa1 100644
--- a/src/include/spi_utils.h
+++ b/src/include/spi_utils.h
@@ -13,7 +13,9 @@
 #define _SPI_UTILS_H_
 
 #include "threads.h"
+#ifndef WIN32
 #include <netinet/in.h> // for endian routines
+#endif
 
 #include "trousers_types.h"
 #include "trousers/trousers.h"
@@ -125,6 +127,7 @@ TSS_RESULT internal_GetCap(TSS_HCONTEXT, TSS_FLAG, UINT32, UINT32 *, BYTE **);
 #define TSS_LOCALHOST_STRING		"localhost"
 TSS_RESULT get_local_random(TSS_HCONTEXT, TSS_BOOL, UINT32, BYTE **);
 
+#define AUTH_RETRY_MILLISEC	500
 #define AUTH_RETRY_NANOSECS	500000000
 #define AUTH_RETRY_COUNT	5
 #define TPM_AUTH_RQU_SIZE	(sizeof(TPM_AUTHHANDLE) + sizeof(TPM_NONCE) \
diff --git a/src/include/tcs_tsp.h b/src/include/tcs_tsp.h
index bba3258..74a0450 100644
--- a/src/include/tcs_tsp.h
+++ b/src/include/tcs_tsp.h
@@ -79,7 +79,11 @@ struct key_disk_cache
 /* XXX Get rid of this, there's no reason to set an arbitrary limit */
 #define MAX_KEY_CHILDREN	10
 
+#ifdef __GNUC__
 #define STRUCTURE_PACKING_ATTRIBUTE	__attribute__((packed))
+#else
+#define STRUCTURE_PACKING_ATTRIBUTE
+#endif
 
 #ifdef TSS_DEBUG
 #define DBG_ASSERT(x)	assert(x)
diff --git a/src/include/tcsd.h b/src/include/tcsd.h
index 1f72e05..7fb417d 100644
--- a/src/include/tcsd.h
+++ b/src/include/tcsd.h
@@ -48,14 +48,23 @@ struct tcsd_config
 							of this TCS System */
 };
 
+#ifdef WIN32
+#define TCSD_CONFIG_FILE	"C://Trousers//tcsd.conf"
+#else
 #define TCSD_CONFIG_FILE	ETC_PREFIX "/tcsd.conf"
+#endif
 
 #define TSS_USER_NAME		"tss"
 #define TSS_GROUP_NAME		"tss"
 
 #define TCSD_DEFAULT_MAX_THREADS	10
+#ifdef WIN32
+#define TCSD_DEFAULT_SYSTEM_PS_FILE	"C://Trousers//system.data"
+#define TCSD_DEFAULT_SYSTEM_PS_DIR	"C://Trousers"
+#else
 #define TCSD_DEFAULT_SYSTEM_PS_FILE	VAR_PREFIX "/lib/tpm/system.data"
 #define TCSD_DEFAULT_SYSTEM_PS_DIR	VAR_PREFIX "/lib/tpm"
+#endif
 #define TCSD_DEFAULT_FIRMWARE_LOG_FILE	"/sys/kernel/security/tpm0/binary_bios_measurements"
 #define TCSD_DEFAULT_KERNEL_LOG_FILE	"/sys/kernel/security/ima/binary_runtime_measurements"
 #define TCSD_DEFAULT_FIRMWARE_PCRS	0x00000000
@@ -156,7 +165,9 @@ void	   *tcsd_thread_run(void *);
 void	   thread_signal_init();
 
 /* signal handling */
+#ifndef WIN32
 struct sigaction tcsd_sa_int;
 struct sigaction tcsd_sa_chld;
+#endif
 
 #endif
diff --git a/src/include/tcsem.h b/src/include/tcsem.h
index 4b1f215..13ec782 100644
--- a/src/include/tcsem.h
+++ b/src/include/tcsem.h
@@ -15,7 +15,7 @@ struct ext_log_source {
         int (*open)(void *, FILE **);
         TSS_RESULT (*get_entries_by_pcr)(FILE *, UINT32, UINT32, UINT32 *, TSS_PCR_EVENT **);
         TSS_RESULT (*get_entry)(FILE *, UINT32, UINT32 *, TSS_PCR_EVENT **);
-        int (*close)(FILE *);
+        int (*file_close)(FILE *);
 };
 
 struct event_wrapper {
diff --git a/src/include/tcslog.h b/src/include/tcslog.h
index 36fdce0..2b6015d 100644
--- a/src/include/tcslog.h
+++ b/src/include/tcslog.h
@@ -13,7 +13,11 @@
 #define _TCSLOG_H_
 
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#else
+#include "win32dep.h"
+#endif
 
 /* log to syslog -- change your syslog destination here */
 #define TSS_SYSLOG_LVL	LOG_LOCAL5
@@ -22,6 +26,8 @@
 #define __FUNCTION__ __func__
 #endif
 
+#ifndef WIN32
+
 #define LogMessage(dest, priority, layer, fmt, ...) \
         do { \
 		if (getenv("TCSD_FOREGROUND") != NULL) { \
@@ -31,6 +37,22 @@
 			syslog(priority, "TrouSerS " fmt "\n", ## __VA_ARGS__); \
 		} \
         } while (0)
+#else
+#define LOG_DEBUG " "
+#define LOG_ERR " "
+#define LOG_INFO " "
+#define LOG_WARNING " "
+
+#define LogMessage(dest, priority, layer, fmt, ...) \
+        do { \
+		if (getenv("TCSD_FOREGROUND") != NULL) { \
+			fprintf(dest, "%s " fmt "\n", layer, ## __VA_ARGS__); \
+		} else { \
+			trousers_log(layer, fmt "\n", ## __VA_ARGS__); \
+		} \
+        } while (0)
+#endif	/* ifndef WIN32 */
+
 
 /* Debug logging */
 #ifdef TSS_DEBUG
diff --git a/src/include/tcsps.h b/src/include/tcsps.h
index 8754296..6e38acc 100644
--- a/src/include/tcsps.h
+++ b/src/include/tcsps.h
@@ -27,6 +27,9 @@ void		   ps_destroy();
 TSS_RESULT  read_data(int, void *, UINT32);
 TSS_RESULT  write_data(int, void *, UINT32);
 #else
+#ifdef WIN32
+#define inline __inline
+#endif
 inline TSS_RESULT  read_data(int, void *, UINT32);
 inline TSS_RESULT  write_data(int, void *, UINT32);
 #endif
diff --git a/src/include/tddl.h b/src/include/tddl.h
index cf5bb3a..1770cb1 100644
--- a/src/include/tddl.h
+++ b/src/include/tddl.h
@@ -16,6 +16,18 @@
 #include "tcsd_wrap.h"
 #include "tcsd.h"
 
+#ifdef WIN32
+#include <windows.h>
+#ifdef __MINGW32__
+#include <specstrings.h>
+#endif
+#include <tbs.h>
+
+struct tpm_device_node {
+	TBS_HCONTEXT hContext;
+	TBS_CONTEXT_PARAMS contextParams;
+};
+#else
 struct tpm_device_node {
 	char *path;
 #define TDDL_TRANSMIT_IOCTL	1
@@ -23,6 +35,7 @@ struct tpm_device_node {
 	int transmit;
 	int fd;
 };
+#endif
 
 #define TDDL_TXBUF_SIZE		2048
 #define TDDL_UNDEF		-1
diff --git a/src/include/threads.h b/src/include/threads.h
index 3c57144..cb97f44 100644
--- a/src/include/threads.h
+++ b/src/include/threads.h
@@ -31,7 +31,7 @@
 #define COND_SIGNAL(c)		pthread_cond_signal(c)
 
 /* thread abstractions */
-#define THREAD_ID			((THREAD_TYPE)pthread_self())
+#define THREAD_ID			(pthread_self())
 #define THREAD_TYPE			pthread_t
 #define THREAD_JOIN			pthread_join
 #define THREAD_DETACH			pthread_detach
diff --git a/src/include/trousers/trousers.h b/src/include/trousers/trousers.h
index 39d8787..c73b83f 100644
--- a/src/include/trousers/trousers.h
+++ b/src/include/trousers/trousers.h
@@ -11,6 +11,19 @@
 #ifndef _TROUSERS_H_
 #define _TROUSERS_H_
 
+#if !defined( TRSPICALL )
+	#if !defined(WIN32) || defined (TRSP_STATIC)
+	// Linux, or a Win32 static library
+		#define TRSPICALL extern
+	#elif defined (TRSPDLL_EXPORTS)
+	// Win32 DLL build
+		#define TRSPICALL extern __declspec(dllexport)
+	#else
+	// Win32 DLL import
+		#define TRSPICALL extern __declspec(dllimport) 
+	#endif
+#endif /* TSPICALL */
+
 #ifdef __cplusplus
 extern "C" {
 #endif
@@ -251,13 +264,13 @@ BYTE *Trspi_UNICODE_To_Native(BYTE *string, unsigned *len);
 /* Error Functions */
 
 /* return a human readable string based on the result */
-char *Trspi_Error_String(TSS_RESULT);
+TRSPICALL char *Trspi_Error_String(TSS_RESULT);
 
 /* return a human readable error layer ( "tpm", "tddl", etc...) */
-char *Trspi_Error_Layer(TSS_RESULT);
+TRSPICALL char *Trspi_Error_Layer(TSS_RESULT);
 
 /* return just the error code bits of the result */
-TSS_RESULT Trspi_Error_Code(TSS_RESULT);
+TRSPICALL TSS_RESULT Trspi_Error_Code(TSS_RESULT);
 
 #ifdef __cplusplus
 }
diff --git a/src/include/trousers_types.h b/src/include/trousers_types.h
index 1c1d79f..68b9c32 100644
--- a/src/include/trousers_types.h
+++ b/src/include/trousers_types.h
@@ -100,7 +100,11 @@ typedef struct tdTSS_KEY11_HDR {
 typedef struct tdTSS_KEY12_HDR {
 	TPM_STRUCTURE_TAG tag;
 	UINT16 fill;
-} __attribute__((packed)) TSS_KEY12_HDR;
+}
+#ifdef __GNUC__
+  __attribute__((packed))
+#endif
+  TSS_KEY12_HDR;
 
 typedef struct tdTSS_KEY {
 	union {
diff --git a/src/include/tsplog.h b/src/include/tsplog.h
index bb2fa6b..3a4ac7b 100644
--- a/src/include/tsplog.h
+++ b/src/include/tsplog.h
@@ -13,7 +13,9 @@
 #define _TSPLOG_H_
 
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <stdlib.h>
 
 /* Debug logging */
diff --git a/src/include/tspps.h b/src/include/tspps.h
index 17b0aab..58a28e6 100644
--- a/src/include/tspps.h
+++ b/src/include/tspps.h
@@ -18,6 +18,9 @@
 
 TSS_RESULT	   get_file(int *);
 int		   put_file(int);
+#ifdef WIN32
+#define inline
+#endif
 inline TSS_RESULT  read_data(int, void *, UINT32);
 inline TSS_RESULT  write_data(int, void *, UINT32);
 UINT32		   psfile_get_num_keys(int);
